
var ForReading = 1
var ForWriting = 2
var ForAppending = 8

var NORESIZE = 0x002	// 0x001  true ƓlƂȂ̂ŎgȂ

var ERROR_MESSAGE_TITLE = "ROAIPlus ErrorInfo"

var MB_OK = 	0x0000
var MB_CANCEL = 0x0001
var MB_ABORTRETRYINGNORE = 0x0002
var MB_RETRYCANCEL = 0x0005
var MB_YESNO = 0x0004
var MB_YESNOCANCEL = 0x0003

var MB_ICONEXCLAMATION = 0x0030
var MB_ICONINFOMATION  = 0x0040
var MB_ICONQUESTION    = 0x0020
var MB_ICONHAND        = 0x0010

var MB_DEFBUTTON1 = 0x0000
var MB_DEFBUTTON2 = 0x0100
var MB_DEFBUTTON3 = 0x0200
var MB_DEFBUTTON4 = 0x0300

var MB_SETFORGROUND = 0x10000
var MB_TOPMOST = 0x40000

var LIF = 1
var AMISTR = 2
var FILIR = 3
var VANILMIRTH = 4

var FOLLOW_CMD_ST = 12

var STATE_TABLE = {
	0 : "IDLE_ST",
	1 : "FOLLOW_ST",
	2 : "CHASE_ST",
	3 : "ATTACK_ST",
	4 : "MOVE_CMD_ST",
	5 : "STOP_CMD_ST",
	6 : "ATTACK_OBJECT_CMD_ST",
	7 : "ATTACK_AREA_CMD_ST",
	8 : "PATROL_CMD_ST",
	9 : "HOLD_CMD_ST",
	10 : "SKILL_OBJECT_CMD_ST",
	11 : "SKILL_AREA_CMD_ST",
	12 : "FOLLOW_CMD_ST"
};

function foreach( c, functor ){
	if( c instanceof Array ){
		for( var i in c ){
			functor( c[i] );
		}
	}else{
		var e = new Enumerator( c );
		for( e.moveFirst(); !e.atEnd(); e.moveNext() ){
			functor( e.item() );
		}
	}
}

function Lock(){
	this.count = 0;
}
function Lock.prototype.enter(){
	this.count++;
}
function Lock.prototype.leave(){
	if( this.count > 0 ){
		this.count--;
	}
}
function Lock.prototype.locked(){
	return this.count != 0;
}
function Lock.prototype.wait(){
	while( this.locked() ){
		WScript.echo("11");
		WScript.Sleep( 100 );
	}
}

var ie = WScript.CreateObject("InternetExplorer.Application", "IE_");
var sh = new ActiveXObject("WScript.Shell");
var fso = new ActiveXObject("Scripting.FileSystemObject");

/*
var uifile = fso.OpenTextFile( fso.BuildPath( sh.CurrentDirectory, "res\\ui.html") )
ie.Navigate("about:blank")
ie.document.open("text/html")
ie.document.charset = "shift_jis";
ie.document.write( uifile.ReadAll() );
uifile.Close();
*/

//ie.AddressBar = false;
//ie.MenuBar = false;
//ie.document.parentWindow.status = "aa";
ie.ToolBar = false;
ie.StatusBar = false;

ie.Width = 268;
ie.Height = 330;

ie.Navigate( fso.BuildPath( sh.CurrentDirectory, "res\\ui.html") );

var lockWindow = new Lock();	// ݂͖gp
var lockConsole = new Lock();

var console;	// \
var popup;
var monitor;

var pause = false;
var refreshCount = 0;

function ToggleConsole( flags ){
	var trace = ie.document.getElementById("trace_ai");
	var contents = ie.document.getElementById("trace_contents");
	var h = contents.offsetHeight;
	if( console ){
		trace.style.height = null;
		trace.style.marginBottom = "0px";
	}else{
		trace.style.height = "1px";
		trace.style.marginBottom = "6px";
	}
	if( flags ^ NORESIZE && IsShownTraceAI() ){
		ie.Height += contents.offsetHeight - h;
	}
	GetTraceOutputElement().innerHTML = "";	// ݂̃g[XNA
	if( console ){
		console.Quit();
		console = null;
	}else{
		console = WScript.CreateObject("InternetExplorer.Application", "IEConsole_");
		console.ToolBar = false;
		console.StatusBar = false;
		console.Top = ie.Top + ie.Height + 5;
		console.Left = ie.Left;
		console.Height = 400;
		console.Width = ie.Width;
		console.Navigate( fso.BuildPath( sh.CurrentDirectory, "res\\console.html") );
		console.Visible = true;
	}
}

function ToggleMonitor(){
	if( monitor ){
		monitor.Quit();
		monitor = null;
	}else{
		monitor = WScript.CreateObject("InternetExplorer.Application", "IEMonitor_");
		monitor.ToolBar = false;
		monitor.StatusBar = false;
		monitor.Top = ie.Top;
		monitor.Left = ie.Left + ie.Width + 5;
		monitor.Height = 130;
		monitor.Width = 250;
		monitor.Navigate( fso.BuildPath( sh.CurrentDirectory, "res\\monitor.html") );
		monitor.Visible = true;
	}
}

function GetTraceOutputElement(){
	if( console ){
		return console.document.getElementById("trace_ai");
	}else{
		return ie.document.getElementById("trace_ai");
	}
}

{
	var popup = ie.document.parentWindow.createPopup();
	function PopupMessage( text ){
		popup.document.body.innerHTML = text;
		popup.show( 200, 200, 400, 200, ie.document.body );
	}
}

function MakeFolder( path ){
	if( !fso.FolderExists( path ) ){
		fso.CreateFolder( path );
	}
}

function IsShownTraceAI(){
	return ie.document.getElementById("show_traceai").value == "ON";
}

function ShowTraceAI( b, flags ){
	var contents = ie.document.getElementById("trace_contents");
	if( b ){
		contents.style.display = "block";
		if( flags ^ NORESIZE ){
			ie.Height += contents.offsetHeight;
		}
	}else{
		if( flags ^ NORESIZE ){
			ie.Height -= contents.offsetHeight;
		}
		contents.style.display = "none";
	}
}

function Unsupported(){
	sh.Popup("łi߂ȂIj", 1.5, "ROAIPlus", 0x10 );
}

function LoadWindowMemberSetting( type, e, w ){
	var state = e.selectSingleNode("state[@name='"+ type +"']");
	if( state ){
		if( Number( state.text ) ){	// l^Ul̂ǂ炩ɕϊ
			w[ type ] = Number( state.text );
		}else{
			w[ type ] = eval( state.text );
		}
	}
}
function SaveWindowMemberSetting( type, e, w ){
	with( e.appendChild( e.ownerDocument.createElement("state") ) ){
		setAttribute("name", type );
		text = String( w[ type ] );
	}
}

function LoadWindowPositionSettings( e, w ){
	if( !w ){
		return;
	}
	foreach( ["top","left","width","height"], function( type ){
		LoadWindowMemberSetting( type, e, w );
	});
}

function SaveWindowPositionSettings( e, w ){
	if( !w ){
		return;
	}
	foreach( ["top","left","width","height"], function( type ){
		SaveWindowMemberSetting( type, e, w );
	});
}

function LoadWindowFormSetting( e, w ){
	var f = w.document.getElementById( e.getAttribute("id") );
	var val = e.firstChild.nodeValue;
	if( f.type == "select-one" ){
		for( var i = 0; i < f.options.length; i++ ){
			if( f.options[i].value == val ){
				f.selectedIndex = i;
				break;
			}
		}
	}else if( f.type == "checkbox" ){
		f.checked = eval( val );	// ^Ulɕϊ
	}else{
		f.value = val;
	}
}

function SaveWindowFormSetting( e, w, id ){
	var f = w.document.getElementById( id );
	var state = e.appendChild( e.ownerDocument.createElement("state") );
	state.setAttribute("id", id );
	var val;
	if( f.type == "select-one" ){
		val = f.options[ f.selectedIndex ].value;
	}else if( f.type == "checkbox" ){
		val = String( f.checked );
	}else{
		val = f.value;
	}
	state.text = val;
}

function LoadAppSettings(){
	var doc = new ActiveXObject("Msxml2.DOMDocument");
	var loaded = doc.load("roaiplus.xml");
	if( loaded ){
		var ieWindow = doc.documentElement.selectSingleNode("window[@name='ie']");
		foreach( ieWindow.selectNodes("state[@id]"), function( node ){
			LoadWindowFormSetting( node, ie );
		});
		LoadWindowPositionSettings( ieWindow, ie );
	}
	if( !IsShownTraceAI() ){
		ShowTraceAI( false, loaded ? NORESIZE : 0 );	//  ݒ胍[h̓TCYȂ
	}
	if( loaded ){
		var consoleWindow = doc.documentElement.selectSingleNode("window[@name='console']");
		var showConsole = consoleWindow.selectSingleNode("state[@name='visible']");
		if( showConsole && eval( showConsole.text ) ){
			ToggleConsole( NORESIZE );
		//	LoadWindowPositionSettings( consoleWindow, console );
		}
		var popupWindow = doc.documentElement.selectSingleNode("window[@name='popup']");
		foreach( popupWindow.selectNodes("state[@id!='plugins']"), function( node ){	// vOCȊO
			LoadWindowFormSetting( node, popup );
		});
		
		var state = popupWindow.selectSingleNode("state[@id='plugins']");
		if( state ){
			var sel = popup.document.getElementById("plugins");
			foreach( state.selectNodes("entry"), function( node ){	// qm[hfVACY
				var option = popup.document.createElement("option");
				option.text = node.text;
				sel.options.add( option );
			});
		}
	}
}

function SaveAppSettings(){
	var doc = new ActiveXObject("Msxml2.DOMDocument");
	doc.appendChild( doc.createProcessingInstruction("xml","version='1.0' encoding='shift-jis'") );
	var root = doc.appendChild( doc.createElement("profile") );
	var ieWindow = root.appendChild( doc.createElement("window") );
	ieWindow.setAttribute("name","ie");
	SaveWindowPositionSettings( ieWindow, ie );
	foreach( ["ai_select","show_traceai","save_traceai","auto_scroll","ignore_repeat"], function( id ){
		SaveWindowFormSetting( ieWindow, ie, id );
	});
	var consoleWindow = root.appendChild( doc.createElement("window") );
	consoleWindow.setAttribute("name","console");
	if( console ){
		SaveWindowMemberSetting("visible", consoleWindow, console );
	//	SaveWindowPositionSettings( consoleWindow, console );
	}
	var popupWindow = root.appendChild( doc.createElement("window") );
	popupWindow.setAttribute("name","popup");
	foreach( ["use_snapshot","quiet_error_message","debug_mode"], function( id ){
		SaveWindowFormSetting( popupWindow, popup, id );
	});
	
	var state = popupWindow.appendChild( doc.createElement("state") );
	state.setAttribute("id", "plugins");
	var sel = popup.document.getElementById("plugins");
	for( var i = 0; i < sel.options.length; i++ ){	// qm[hVACY
		var entry = state.appendChild( doc.createElement("entry") );
		entry.text = sel.options[i].text;
	}
	
	doc.save("roaiplus.xml");
}

{
	MakeFolder("temp");
	MakeFolder("temp/TraceAI");
	MakeFolder("temp/Errors");
	
	while(true){
		WScript.Sleep( 100 );
		if( !ie.Visible ){	// IE_DocumentCompleteł̏܂ł͑ҋ@
			continue;
		}
		try{	// rIEIĂG[oɏI
			Run();
			
		}catch( ex ){
			var num = ex.number & 0xFFFF
			if( !popup.document.getElementById("debug_mode").checked ){
				if( num == 264 ){	// 炭R\[ۂ̃G[
					continue;
				}
			}
			var err = 
				"XNvg̃[vŃG[܂B\n"+
				ex.name +" :"+ num +" "+ ex.message +"\n\n"+
				"G[̏ڍׂɂOK{^ĂB\nXNvg̎s͒~܂B\n\n"+
				"s𑱂ꍇ̓LZĂB";
			var r = sh.Popup( err, 0, ERROR_MESSAGE_TITLE, MB_CANCEL | MB_ICONHAND | MB_DEFBUTTON2 | MB_SETFORGROUND );
			if( r == 0x01 ){
				throw ex;
			}
		}
	}
	
	var prevDate = new Date( 0 );
	
	function ApplyTraceAI(){
		var trace = GetTraceOutputElement();
		foreach( fso.GetFolder("temp/TraceAI").Files, function( file ){	// Files͖OɃ\[gĂi͂j
			var num = Number( file.Name );	// t@C𐔒l
			if( !num ){
				return;
			}
			if( file.DateLastModified < prevDate ){
				return;	// Ât@C炱ȍ~͖
			}
			prevDate = file.DateLastModified;
			var is = file.OpenAsTextStream();
			var buf = [];
			while( !is.AtEndOfStream ){
				buf.push( is.ReadLine() );
				buf.push("\r");	// ȂAȂƂȂہH
			}
			is.Close();
			trace.insertAdjacentText("BeforeEnd", buf.join("") );
			if( ie.document.getElementById("auto_scroll").checked ){
				var range = trace.createTextRange();
				range.move("textedit");
				range.scrollIntoView( false );	// ԉ܂ŃXN[
			}
			file.Delete();
		});
	}
	
	function UpdateHPSP( name, e ){
		if( !e ){
			return;
		}
		var hp = e.getAttribute("hp");
		var sp = e.getAttribute("sp");
		var mhp = e.getAttribute("mhp");
		var msp = e.getAttribute("msp");
		monitor.document.getElementById( name +"_hp_value").innerHTML = hp +"/"+ mhp;
		monitor.document.getElementById( name +"_sp_value").innerHTML = sp +"/"+ msp;
		monitor.document.getElementById( name +"_hp_gauge").style.width = ( hp / mhp * 100 ) +"%";
		monitor.document.getElementById( name +"_sp_gauge").style.width = ( sp / msp * 100 ) +"%";
	}
	
	function ReadSnapshot(){
		var doc = new ActiveXObject("Msxml2.DOMDocument");
		if( doc.load("temp/Snapshot.xml") ){
			if( monitor ){
				var varlist = [];
				foreach( doc.documentElement.selectNodes("variable"), function( node ){
					varlist[ node.getAttribute("name") ] = node.firstChild.nodeValue;
				});
				var mystate = monitor.document.getElementById("my_state");
				var state = STATE_TABLE[ varlist.MyState ];
				if( state ){
					mystate.value = state;
				}else{
					mystate.value = varlist.MyState +" (`)";
				}
				var follow = monitor.document.getElementById("follow_cmd_st");
				follow.style.visibility = varlist.MyState == FOLLOW_CMD_ST ? "visible" : "hidden";	// FOLLOW_CMD_ST
			}
			var homun = doc.documentElement.selectSingleNode("homunculus/actor");
			if( homun && console ){
				var image;
				switch( Number( homun.getAttribute("homunType") ) ){
					case LIF:
						image = "images/LIF.gif";
						break;
					case AMISTR:
						image = "images/AMISTR.gif";
						break;
					case FILIR:
						image = "images/FILIR.gif";
						break;
					case VANILMIRTH:
						image = "images/VANILMIRTH.gif";
						break;
				}
				console.document.body.style.backgroundImage = "url("+ image +")";
			}
			var owner = doc.documentElement.selectSingleNode("owner/actor");
			if( monitor ){
				UpdateHPSP("homun", homun );
				UpdateHPSP("owner", owner );
			}
		}
	}
	
	var prevError = new Date( 0 );
	
	function NotifyErrorMessage(){
		foreach( fso.GetFolder("temp/Errors").Files, function( file ){
			var num = Number( file.Name );
			if( !num ){
				return;
			}
			if( file.DateLastModified < prevError ){
				return;
			}
			prevError = file.DateLastModified;
			var is = file.OpenAsTextStream();
			WScript.Echo( is.ReadAll() );
			is.Close();
			
			file.Delete();
		});
	}
	
	function Run(){
		NotifyErrorMessage();
		if( popup.document.getElementById("use_snapshot").checked ){
			ReadSnapshot();
		}else{
			if( monitor ){
				monitor.document.getElementById("my_state").value = "Disabled";
				monitor.document.getElementById("follow_cmd_st").style.visibility = "hidden";
			}
			if( console ){
				console.document.body.style.backgroundImage = "";
			}
		}
		lockWindow.enter();
		if( IsShownTraceAI() ){
			lockConsole.enter();
			ApplyTraceAI();
			lockConsole.leave();
		}
		
		var sel = GetSelectedAI();
		lockWindow.leave();
		var os = fso.OpenTextFile("params.lua", ForWriting, true );
		os.WriteLine("return {");
		if( sel ){
			os.WriteLine("	CURRENT_AI = \""+ sel +"\",");
		}else{
			os.WriteLine("	CURRENT_AI = nil,");
		}
		os.WriteLine("	HOOK_TRACEAI = "+ IsShownTraceAI() +",");
		os.WriteLine("	SAVE_TRACEAI = "+ ie.document.getElementById("save_traceai").checked +",");
		os.WriteLine("	IGNORE_REPEAT = "+ ie.document.getElementById("ignore_repeat").checked +",");
		os.WriteLine("	USE_SNAPSHOT = "+ popup.document.getElementById("use_snapshot").checked +",");
		os.WriteLine("	QUIET_ERROR_MESSAGE = "+ popup.document.getElementById("quiet_error_message").checked +",");
		os.WriteLine("	REFRESH_COUNT = "+ refreshCount +",");
		os.WriteLine("	PAUSE = "+ pause +",");
		os.WriteLine("	PLUGINS = {");
		os.Write("		");
		var plugs = popup.document.getElementById("plugins");
		for( var i = 0; i < plugs.options.length; i++ ){
			os.Write('"'+ plugs.options[i].text +'",');
		}
		os.WriteLine();
		os.WriteLine("	},");
		os.WriteLine("}");
		os.Close();
	}
	
	var prevSelected;
	
	function GetSelectedAI(){
		var select = ie.document.getElementById("ai_select");
		if( select.selectedIndex == 0 ){	// ftHg̑I
			return prevSelected;	// ȑOÎԂ
		}
		var opt = select.options[ select.selectedIndex ];
		prevSelected = opt.value;
		return opt.value;
	}
}

{
	function InitializeOptions(){
		popup = ie.document.parentWindow.createPopup();
		popup.document.body.innerHTML = ie.document.getElementById("options").outerHTML;	// ev[gRs[
		popup.document.createStyleSheet().cssText = fso.OpenTextFile("res/options.css").ReadAll();
	//	popup.document.body.style.margin = "1em";
		popup.document.getElementById("about_link").onclick = function(){
			ie.document.parentWindow.open( this.href );
		};
		popup.document.getElementById("close_options").onclick = function(){
			popup.hide();
		};
		
		var sel = popup.document.getElementById("plugins");
		var AddPluginEntry = function( name ){
			var option = popup.document.createElement("option");
			option.text = name;
			sel.options.add( option );
		};
		popup.document.getElementById("add_plugin").onclick = function(){
			var dlg;
			try{
				dlg = WScript.CreateObject("MscomDlg.CommonDialog");
			}catch( ex ){	// IuWFNg쐬ɎsꍇAփ_CAOo
				var name = ie.document.parentWindow.prompt("vOCw肵Ă \tUSER_AI\\plugins\\<vOC>.lua","");
				if( name ){
					if( fso.FileExists("plugins/"+ name +".lua") ){
						AddPluginEntry( name );
					}else{
						sh.Popup( "t@C܂", 0, ERROR_MESSAGE_TITLE, MB_ICONHAND | MB_SETFORGROUND );
					}
				}
			}
			if( dlg ){
				dlg.MaxFileSize = 256;
				dlg.Filter = "LuaXNvgt@C (*.lua)|*.lua";
				dlg.InitDir = "plugins";
			//	dlg.FileName = defname;
				var cd = sh.CurrentDirectory;
				dlg.ShowOpen();
				if( dlg.FileName.length > 0 ){	// t@CύXĂ
					sh.CurrentDirectory = cd;	// R_CAÔŃJgfBNgpluginsɂȂĂ܂
					AddPluginEntry( fso.GetBaseName( dlg.FileName ) );
				}
			}
			ie.document.getElementById("open_options").click();	// EBhEĕ\
		};
		popup.document.getElementById("remove_plugin").onclick = function(){
			var index = sel.selectedIndex;
			if( index == -1 ){
				return;
			}
			sel.options.remove( index );
		};
		popup.document.getElementById("refresh_plugin").onclick = function(){
			ie.document.getElementById("refresh").click();
		};
	}
	
	function ApplyOptions(){
		/*
		var useSnapshot = popup.document.getElementById("use_snapshot").checked;
		var disp = ie.document.getElementById("state").style.display;
		var height = ie.document.getElementById("state").offsetHeight;
		if( useSnapshot && disp == "none" ){
			ie.Height += height;
		}
		ie.document.getElementById("state").style.display = useSnapshot ? "block" : "none";
		if( !useSnapshot && disp == "block" ){
			ie.Height -= height;
		}
		*/
	}
}

function IE_DocumentComplete(){
	var select = ie.document.getElementById("ai_select");
	foreach( fso.GetFolder("..\\").SubFolders,
		function( item ){
			if( item.Name == "USER_AI" ){	// ROAIPlus̃tH_͖
				return;
			}
			var e = ie.document.createElement("option");
			e.value = item.Name;
			e.text = item.Name;
			select.add( e );
		});
	InitializeOptions();
	LoadAppSettings();
	
	ie.document.getElementById("show_traceai").onclick = function(){
		if( this.value == "ON" ){
			this.value = "OFF";
			ShowTraceAI( false );
		}else if( this.value == "OFF" ){
			this.value = "ON";
			ShowTraceAI( true );
		}else{
			throw new Error("show_traceai illiegal value");
		}
	};
	
	ie.document.getElementById("trace_popup").onclick = function(){
		ToggleConsole();
	};
	
	ie.document.getElementById("trace_save").onclick = function(){
		var defname = "TraceAI.txt";
		var filename;
		var dlg;
		try{
			dlg = WScript.CreateObject("MscomDlg.CommonDialog");
		}catch( ex ){	// փ_CAO
			var filename = ie.document.parentWindow.prompt("ۑw肵Ă", fso.BuildPath( sh.CurrentDirectory, defname ) );
		}
		if( dlg ){
			dlg.MaxFileSize = 256;
			dlg.Filter = "eLXg (*.txt)|*.txt";
			dlg.InitDir = ".";
			dlg.FileName = defname;
			dlg.ShowSave();
			if( dlg.FileName.length > 0 && dlg.FileName != defname ){	// t@CύXĂ
				filename = dlg.FileName;
			}
		}
		if( filename ){
			var os = fso.OpenTextFile( filename, ForWriting, true );
			os.Write( GetTraceOutputElement().innerText );
			os.Close();
		}
	};
	
	ie.document.getElementById("trace_clear").onclick = function(){
		GetTraceOutputElement().innerText = "";
	};
	
	var height;	//  ie.Height ۑ
	popup.document.body.onunload = function(){
		ie.Height = height;
	//	ApplyOptions();
	};
	ie.document.body.onhelp = ie.document.getElementById("open_options").onclick = function(){
		popup.hide();	// F1Ałۂ̂߂ɂ܂
		height = ie.Height;
		var h = ie.document.getElementById("options").offsetHeight;
		ie.Height = Math.max( ie.Height, ie.Height - ie.document.body.offsetHeight + h );	// |bvAbṽTCYɂ킹
		popup.show( 0, 0, 400, h, ie.document.body );
		return false;
	};
	ie.document.getElementById("pause").onclick = function(){
		pause = !pause;
	};
	ie.document.getElementById("refresh").onclick = function(){
		refreshCount++;
	};
	ie.document.getElementById("open_monitor").onclick = function(){
		ToggleMonitor();
	};
	
	ie.document.body.onunload = function(){	// F5L[ȂǂɏI
		ie.Quit();
	};
	
	ie.Visible = true;
}

function IE_OnQuit(){
	SaveAppSettings();
	if( console ){
		console.Quit();
	}
	if( monitor ){
		monitor.Quit();
	}
	WScript.Quit();
};

function IEConsole_OnQuit(){
	if( console ){	// {^ɂďI悤ƂĂȂ
		ToggleConsole();
	}
};

function IEMonitor_OnQuit(){
	if( monitor ){
		ToggleMonitor();
	}
};
